package com.nkkj.ups.result;

import jakarta.servlet.http.HttpServletResponse;
import lombok.Data;

@Data
public class R<T> {
    private int status;
    /**
     * 异常编号
     */
    private String errorCode;
    /**
     * 异常信息
     */
    private String message;
    /**
     * 响应数据
     */
    private T data;
    public static <T> R<T> success() {
        return success(200, null, null);
    }

    public static <T> R<T> success(T data) {
        return success(HttpServletResponse.SC_OK, null, data);
    }

    public static <T> R<T> fail(String message) {
        return fail(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, null, message, null);
    }

    public static <T> R<T> fail(String errorCode, String message) {
        return fail(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, errorCode, message, null);
    }

    public static <T> R<T> success(int status, String message, T data) {
        R<T> r = new R<>();
        r.setStatus(status);
        r.setMessage(message);
        r.setData(data);

        return r;
    }

    public static <T> R<T> fail(int status, String errorCode, String message) {
        return fail(status, errorCode, message, null);
    }

    public static <T> R<T> fail(int status, String errorCode, String message, T data) {
        R<T> r = new R<>();
        r.setStatus(status);
        r.setErrorCode(errorCode);
        r.setMessage(message);
        r.setData(data);
        return r;
    }
}
