package com.nkkj.ups.utils.JWT;


import generator.domain.User;
import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;
import org.springframework.boot.autoconfigure.security.oauth2.resource.OAuth2ResourceServerProperties;
import org.springframework.stereotype.Component;

import javax.crypto.SecretKey;
import java.util.Date;
@Component
public class JwtUtils {
    public static SecretKey secretKey=getSigningKey();
    public String createToken(User user) {
        return Jwts.builder()
                .subject(user.getName())
                .issuedAt(new Date())
                .expiration(new Date(new Date().getTime()+1000*60*60*24))
                .signWith(secretKey)
                .compact();
    }
    public Claims decodeToken(String token) {
        return Jwts.parser().verifyWith(secretKey).build().parseSignedClaims(token).getPayload();

//        Jwts.claims().
//        Jwts.parser().setSigningKey().
    }

    public static SecretKey getSigningKey() {
        return Jwts.SIG.HS256.key().build();
    }
}
